Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontengine.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine.cpp
@@ -102,7 +102,7 @@ bool qt_useHarfbuzzNG()
 }
 #endif
 
-Q_STATIC_ASSERT(sizeof(HB_Glyph) == sizeof(glyph_t));
+Q_STATIC_ASSERT(sizeof(HB_Glyph) == sizeof(glyph__t));
 Q_STATIC_ASSERT(sizeof(HB_Fixed) == sizeof(QFixed));
 
 static HB_Bool hb_stringToGlyphs(HB_Font font, const HB_UChar16 *string, hb_uint32 length, HB_Glyph *glyphs, hb_uint32 *numGlyphs, HB_Bool rightToLeft)
@@ -111,21 +111,37 @@ static HB_Bool hb_stringToGlyphs(HB_Font
 
     const QChar *str = reinterpret_cast<const QChar *>(string);
 
+    QVarLengthArray<QGlyph> tmpGlyphsArray(*numGlyphs);
+
     QGlyphLayout qglyphs;
     qglyphs.numGlyphs = *numGlyphs;
-    qglyphs.glyphs = glyphs;
+    qglyphs.glyphs = tmpGlyphsArray.data();
     int nGlyphs = *numGlyphs;
     bool result = fe->stringToCMap(str, length, &qglyphs, &nGlyphs, QFontEngine::GlyphIndicesOnly);
     *numGlyphs = nGlyphs;
 
     if (rightToLeft && result && !fe->symbol) {
         QStringIterator it(str, str + length);
+        const QGlyph *itGlyph = tmpGlyphsArray.data();
         while (it.hasNext()) {
             const uint ucs4 = it.next();
             const uint mirrored = QChar::mirroredChar(ucs4);
             if (Q_UNLIKELY(mirrored != ucs4))
-                *glyphs = fe->glyphIndex(mirrored);
+                *glyphs = fe->glyphIndex(mirrored).glyph;
+            else
+                *glyphs = itGlyph->glyph;
             ++glyphs;
+            ++itGlyph;
+        }
+    }
+    else
+    {
+        const QGlyph *itGlyph = tmpGlyphsArray.data();
+        while (nGlyphs) {
+            *glyphs = itGlyph->glyph;
+            ++glyphs;
+            ++itGlyph;
+            --nGlyphs;
         }
     }
 
@@ -135,10 +151,16 @@ static HB_Bool hb_stringToGlyphs(HB_Font
 static void hb_getAdvances(HB_Font font, const HB_Glyph *glyphs, hb_uint32 numGlyphs, HB_Fixed *advances, int flags)
 {
     QFontEngine *fe = (QFontEngine *)font->userData;
+    QVarLengthArray<QGlyph> tmpGlyphsArray(numGlyphs);
 
     QGlyphLayout qglyphs;
     qglyphs.numGlyphs = numGlyphs;
-    qglyphs.glyphs = const_cast<glyph_t *>(glyphs);
+    qglyphs.glyphs = tmpGlyphsArray.data();
+
+    QGlyph *it = qglyphs.glyphs;
+    for (int i = 0; i < numGlyphs; ++i, ++glyphs, ++it) {
+        *it = QGlyph{0, *glyphs};
+    }
     qglyphs.advances = reinterpret_cast<QFixed *>(advances);
 
     fe->recalcAdvances(&qglyphs, (flags & HB_ShaperFlag_UseDesignMetrics) ? QFontEngine::DesignMetrics : QFontEngine::ShaperFlags(0));
@@ -153,7 +175,9 @@ static HB_Bool hb_canRender(HB_Font font
 static void hb_getGlyphMetrics(HB_Font font, HB_Glyph glyph, HB_GlyphMetrics *metrics)
 {
     QFontEngine *fe = (QFontEngine *)font->userData;
-    glyph_metrics_t m = fe->boundingBox(glyph);
+    QGlyph g;
+    g.glyph = glyph;
+    glyph_metrics_t m = fe->boundingBox(g);
     metrics->x = m.x.value();
     metrics->y = m.y.value();
     metrics->width = m.width.value();
@@ -171,7 +195,7 @@ static HB_Fixed hb_getFontMetric(HB_Font
     return 0;
 }
 
-int QFontEngine::getPointInOutline(glyph_t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints)
+int QFontEngine::getPointInOutline(glyph__t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints)
 {
     Q_UNUSED(glyph)
     Q_UNUSED(flags)
@@ -400,14 +424,14 @@ bool QFontEngine::canRender(const QChar
 {
     QStringIterator it(str, str + len);
     while (it.hasNext()) {
-        if (glyphIndex(it.next()) == 0)
+        if (glyphIndex(it.next()).glyph == 0)
             return false;
     }
 
     return true;
 }
 
-glyph_metrics_t QFontEngine::boundingBox(glyph_t glyph, const QTransform &matrix)
+glyph_metrics_t QFontEngine::boundingBox(const QGlyph &glyph, const QTransform &matrix)
 {
     glyph_metrics_t metrics = boundingBox(glyph);
 
@@ -419,21 +443,21 @@ glyph_metrics_t QFontEngine::boundingBox
 
 QFixed QFontEngine::calculatedCapHeight() const
 {
-    const glyph_t glyph = glyphIndex('H');
+    const QGlyph glyph = glyphIndex('H');
     glyph_metrics_t bb = const_cast<QFontEngine *>(this)->boundingBox(glyph);
     return bb.height;
 }
 
 QFixed QFontEngine::xHeight() const
 {
-    const glyph_t glyph = glyphIndex('x');
+    const QGlyph glyph = glyphIndex('x');
     glyph_metrics_t bb = const_cast<QFontEngine *>(this)->boundingBox(glyph);
     return bb.height;
 }
 
 QFixed QFontEngine::averageCharWidth() const
 {
-    const glyph_t glyph = glyphIndex('x');
+    const QGlyph glyph = glyphIndex('x');
     glyph_metrics_t bb = const_cast<QFontEngine *>(this)->boundingBox(glyph);
     return bb.xoff;
 }
@@ -449,7 +473,7 @@ bool QFontEngine::expectsGammaCorrectedB
 }
 
 void QFontEngine::getGlyphPositions(const QGlyphLayout &glyphs, const QTransform &matrix, QTextItem::RenderFlags flags,
-                                    QVarLengthArray<glyph_t> &glyphs_out, QVarLengthArray<QFixedPoint> &positions)
+                                    QVarLengthArray<QGlyph> &glyphs_out, QVarLengthArray<QFixedPoint> &positions)
 {
     QFixed xpos;
     QFixed ypos;
@@ -494,12 +518,12 @@ void QFontEngine::getGlyphPositions(cons
             }
             positions[current].x = gpos_x;
             positions[current].y = gpos_y;
-            glyphs_out[current] = glyphs.glyphs[i];
+            glyphs_out[current] = glyphs.at(i);
             ++current;
             if (glyphs.justifications[i].nKashidas) {
                 QChar ch(0x640); // Kashida character
 
-                glyph_t kashidaGlyph = glyphIndex(ch.unicode());
+                QGlyph kashidaGlyph = glyphIndex(ch.unicode());
                 QFixed kashidaWidth;
 
                 QGlyphLayout g;
@@ -538,7 +562,7 @@ void QFontEngine::getGlyphPositions(cons
                 if (!glyphs.attributes[i].dontPrint) {
                     positions[current].x = xpos + glyphs.offsets[i].x;
                     positions[current].y = ypos + glyphs.offsets[i].y;
-                    glyphs_out[current] = glyphs.glyphs[i];
+                    glyphs_out[current] = glyphs.at(i);
                     xpos += glyphs.advances[i] + QFixed::fromFixed(glyphs.justifications[i].space_18d6);
                     ++current;
                 }
@@ -553,7 +577,7 @@ void QFontEngine::getGlyphPositions(cons
                     gpos = gpos * matrix;
                     positions[current].x = QFixed::fromReal(gpos.x());
                     positions[current].y = QFixed::fromReal(gpos.y());
-                    glyphs_out[current] = glyphs.glyphs[i];
+                    glyphs_out[current] = glyphs.at(i);
                     xpos += glyphs.advances[i] + QFixed::fromFixed(glyphs.justifications[i].space_18d6);
                     ++current;
                 }
@@ -566,7 +590,7 @@ void QFontEngine::getGlyphPositions(cons
     Q_ASSERT(positions.size() == glyphs_out.size());
 }
 
-void QFontEngine::getGlyphBearings(glyph_t glyph, qreal *leftBearing, qreal *rightBearing)
+void QFontEngine::getGlyphBearings(const QGlyph &glyph, qreal *leftBearing, qreal *rightBearing)
 {
     glyph_metrics_t gi = boundingBox(glyph);
     if (leftBearing != 0)
@@ -634,8 +658,8 @@ qreal QFontEngine::minRightBearing() con
             m_minLeftBearing = m_minRightBearing = std::numeric_limits<qreal>::max();
 
             for (uint i = 0; i < (sizeof(characterSubset) / sizeof(ushort)); ++i) {
-                const glyph_t glyph = glyphIndex(characterSubset[i]);
-                if (!glyph)
+                const QGlyph glyph = glyphIndex(characterSubset[i]);
+                if (!glyph.glyph)
                     continue;
 
                 glyph_metrics_t glyphMetrics = const_cast<QFontEngine *>(this)->boundingBox(glyph);
@@ -663,7 +687,7 @@ glyph_metrics_t QFontEngine::tightBoundi
     QFixed ymax = 0;
     QFixed xmax = 0;
     for (int i = 0; i < glyphs.numGlyphs; i++) {
-        glyph_metrics_t bb = boundingBox(glyphs.glyphs[i]);
+        glyph_metrics_t bb = boundingBox(glyphs.at(i));
         QFixed x = overall.xoff + glyphs.offsets[i].x + bb.x;
         QFixed y = overall.yoff + glyphs.offsets[i].y + bb.y;
         overall.x = qMin(overall.x, x);
@@ -687,7 +711,7 @@ void QFontEngine::addOutlineToPath(qreal
         return;
 
     QVarLengthArray<QFixedPoint> positions;
-    QVarLengthArray<glyph_t> positioned_glyphs;
+    QVarLengthArray<QGlyph> positioned_glyphs;
     QTransform matrix = QTransform::fromTranslate(x, y);
     getGlyphPositions(glyphs, matrix, flags, positioned_glyphs, positions);
     addGlyphsToPath(positioned_glyphs.data(), positions.data(), positioned_glyphs.size(), path, flags);
@@ -795,12 +819,12 @@ void QFontEngine::addBitmapFontToPath(qr
     QFixed advanceX = QFixed::fromReal(x);
     QFixed advanceY = QFixed::fromReal(y);
     for (int i=0; i < glyphs.numGlyphs; ++i) {
-        glyph_metrics_t metrics = boundingBox(glyphs.glyphs[i]);
+        glyph_metrics_t metrics = boundingBox(glyphs.at(i));
         if (metrics.width.value() == 0 || metrics.height.value() == 0) {
             advanceX += glyphs.advances[i];
             continue;
         }
-        const QImage alphaMask = alphaMapForGlyph(glyphs.glyphs[i]);
+        const QImage alphaMask = alphaMapForGlyph(glyphs.at(i));
 
         const int w = alphaMask.width();
         const int h = alphaMask.height();
@@ -836,7 +860,7 @@ void QFontEngine::addBitmapFontToPath(qr
     }
 }
 
-void QFontEngine::addGlyphsToPath(glyph_t *glyphs, QFixedPoint *positions, int nGlyphs,
+void QFontEngine::addGlyphsToPath(const QGlyph *glyphs, QFixedPoint *positions, int nGlyphs,
                                   QPainterPath *path, QTextItem::RenderFlags flags)
 {
     qreal x = positions[0].x.toReal();
@@ -853,13 +877,13 @@ void QFontEngine::addGlyphsToPath(glyph_
     addBitmapFontToPath(x, y, g, path, flags);
 }
 
-QImage QFontEngine::alphaMapForGlyph(glyph_t glyph, QFixed /*subPixelPosition*/)
+QImage QFontEngine::alphaMapForGlyph(const QGlyph &glyph, QFixed /*subPixelPosition*/)
 {
     // For font engines don't support subpixel positioning
     return alphaMapForGlyph(glyph);
 }
 
-QImage QFontEngine::alphaMapForGlyph(glyph_t glyph, const QTransform &t)
+QImage QFontEngine::alphaMapForGlyph(const QGlyph &glyph, const QTransform &t)
 {
     QImage i = alphaMapForGlyph(glyph);
     if (t.type() > QTransform::TxTranslate)
@@ -869,7 +893,7 @@ QImage QFontEngine::alphaMapForGlyph(gly
     return i;
 }
 
-QImage QFontEngine::alphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition, const QTransform &t)
+QImage QFontEngine::alphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition, const QTransform &t)
 {
     if (! supportsSubPixelPositions())
         return alphaMapForGlyph(glyph, t);
@@ -882,7 +906,7 @@ QImage QFontEngine::alphaMapForGlyph(gly
     return i;
 }
 
-QImage QFontEngine::alphaRGBMapForGlyph(glyph_t glyph, QFixed /*subPixelPosition*/, const QTransform &t)
+QImage QFontEngine::alphaRGBMapForGlyph(const QGlyph &glyph, QFixed /*subPixelPosition*/, const QTransform &t)
 {
     const QImage alphaMask = alphaMapForGlyph(glyph, t);
     QImage rgbMask(alphaMask.width(), alphaMask.height(), QImage::Format_RGB32);
@@ -899,7 +923,7 @@ QImage QFontEngine::alphaRGBMapForGlyph(
     return rgbMask;
 }
 
-QImage QFontEngine::bitmapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform&, const QColor &)
+QImage QFontEngine::bitmapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform&, const QColor &)
 {
     Q_UNUSED(subPixelPosition);
 
@@ -923,7 +947,7 @@ QFixed QFontEngine::subPixelPositionForX
     return subPixelPosition;
 }
 
-QImage *QFontEngine::lockedAlphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition,
+QImage *QFontEngine::lockedAlphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition,
                                             QFontEngine::GlyphFormat neededFormat,
                                             const QTransform &t, QPoint *offset)
 {
@@ -948,7 +972,7 @@ void QFontEngine::unlockAlphaMapForGlyph
     currentlyLockedAlphaMap = QImage();
 }
 
-QImage QFontEngine::alphaMapForGlyph(glyph_t glyph)
+QImage QFontEngine::alphaMapForGlyph(const QGlyph &glyph)
 {
     glyph_metrics_t gm = boundingBox(glyph);
     int glyph_x = qFloor(gm.x.toReal());
@@ -985,7 +1009,7 @@ QImage QFontEngine::alphaMapForGlyph(gly
     return alphaMap;
 }
 
-void QFontEngine::removeGlyphFromCache(glyph_t)
+void QFontEngine::removeGlyphFromCache(const QGlyph &)
 {
 }
 
@@ -1009,7 +1033,7 @@ QFontEngine::Properties QFontEngine::pro
     return p;
 }
 
-void QFontEngine::getUnscaledGlyph(glyph_t glyph, QPainterPath *path, glyph_metrics_t *metrics)
+void QFontEngine::getUnscaledGlyph(const QGlyph &glyph, QPainterPath *path, glyph_metrics_t *metrics)
 {
     *metrics = boundingBox(glyph);
     QFixedPoint p;
@@ -1125,10 +1149,10 @@ void QFontEngine::doKerning(QGlyphLayout
 
     if (flags & DesignMetrics) {
         for(int i = 0; i < glyphs->numGlyphs - 1; ++i)
-            glyphs->advances[i] += kerning(glyphs->glyphs[i], glyphs->glyphs[i+1] , pairs, numPairs);
+            glyphs->advances[i] += kerning(glyphs->glyphs[i].glyph, glyphs->glyphs[i+1].glyph , pairs, numPairs);
     } else {
         for(int i = 0; i < glyphs->numGlyphs - 1; ++i)
-            glyphs->advances[i] += qRound(kerning(glyphs->glyphs[i], glyphs->glyphs[i+1] , pairs, numPairs));
+            glyphs->advances[i] += qRound(kerning(glyphs->glyphs[i].glyph, glyphs->glyphs[i+1].glyph , pairs, numPairs));
     }
 }
 
@@ -1563,7 +1587,7 @@ bool QFontEngine::hasUnreliableGlyphOutl
 QFixed QFontEngine::lastRightBearing(const QGlyphLayout &glyphs, bool round)
 {
     if (glyphs.numGlyphs >= 1) {
-        glyph_t glyph = glyphs.glyphs[glyphs.numGlyphs - 1];
+        const QGlyph glyph = glyphs.at(glyphs.numGlyphs - 1);
         glyph_metrics_t gi = boundingBox(glyph);
         if (gi.isValid())
             return round ? qRound(gi.rightBearing()) : gi.rightBearing();
@@ -1613,10 +1637,10 @@ QFontEngineBox::~QFontEngineBox()
 {
 }
 
-glyph_t QFontEngineBox::glyphIndex(uint ucs4) const
+QGlyph QFontEngineBox::glyphIndex(uint ucs4) const
 {
     Q_UNUSED(ucs4)
-    return 0;
+    return {};
 }
 
 bool QFontEngineBox::stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, QFontEngine::ShaperFlags flags) const
@@ -1631,7 +1655,7 @@ bool QFontEngineBox::stringToCMap(const
     QStringIterator it(str, str + len);
     while (it.hasNext()) {
         it.advance();
-        glyphs->glyphs[ucs4Length++] = 0;
+        glyphs->glyphs[ucs4Length++] = QGlyph{0, 0};
     }
 
     *nglyphs = ucs4Length;
@@ -1655,7 +1679,7 @@ void QFontEngineBox::addOutlineToPath(qr
         return;
 
     QVarLengthArray<QFixedPoint> positions;
-    QVarLengthArray<glyph_t> positioned_glyphs;
+    QVarLengthArray<QGlyph> positioned_glyphs;
     QTransform matrix = QTransform::fromTranslate(x, y - _size);
     getGlyphPositions(glyphs, matrix, flags, positioned_glyphs, positions);
 
@@ -1682,7 +1706,7 @@ void QFontEngineBox::draw(QPaintEngine *
     QSize s(_size - 3, _size - 3);
 
     QVarLengthArray<QFixedPoint> positions;
-    QVarLengthArray<glyph_t> glyphs;
+    QVarLengthArray<QGlyph> glyphs;
     QTransform matrix = QTransform::fromTranslate(x, y - _size);
     ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
     if (glyphs.size() == 0)
@@ -1700,7 +1724,7 @@ void QFontEngineBox::draw(QPaintEngine *
     painter->restore();
 }
 
-glyph_metrics_t QFontEngineBox::boundingBox(glyph_t)
+glyph_metrics_t QFontEngineBox::boundingBox(const QGlyph &)
 {
     return glyph_metrics_t(0, -_size, _size, _size, _size, 0);
 }
@@ -1742,7 +1766,7 @@ bool QFontEngineBox::canRender(const QCh
     return true;
 }
 
-QImage QFontEngineBox::alphaMapForGlyph(glyph_t)
+QImage QFontEngineBox::alphaMapForGlyph(const QGlyph &)
 {
     QImage image(_size, _size, QImage::Format_Alpha8);
     image.fill(0);
@@ -1761,13 +1785,6 @@ QImage QFontEngineBox::alphaMapForGlyph(
 // Multi engine
 // ------------------------------------------------------------------
 
-uchar QFontEngineMulti::highByte(glyph_t glyph)
-{ return glyph >> 24; }
-
-// strip high byte from glyph
-static inline glyph_t stripped(glyph_t glyph)
-{ return glyph & 0x00ffffff; }
-
 QFontEngineMulti::QFontEngineMulti(QFontEngine *engine, int script, const QStringList &fallbackFamilies)
     : QFontEngine(Multi),
       m_fallbackFamilies(fallbackFamilies),
@@ -1825,6 +1842,18 @@ void QFontEngineMulti::setFallbackFamili
     } else {
         m_engines.resize(m_fallbackFamilies.size() + 1);
     }
+    qDebug() << "----- fallbackFamilies:";
+    for (int i = 0; i < m_fallbackFamilies.size(); ++i) {
+        qDebug() << i << ") " << m_fallbackFamilies.at(i);
+    }
+    qDebug() << "----- engines:";
+
+    for (int i = 0; i < m_engines.size(); ++i) {
+        QFontEngine *engine = m_engines.at(i);
+        if (engine)
+            qDebug() << i << ") " << engine->fontDef.family << " : " << engine->fontDef.families << " ; " << engine->fontDef.fallBackFamilies;
+    }
+    qDebug() << "------------------";
 
     m_fallbackFamiliesQueried = true;
 }
@@ -1834,7 +1863,9 @@ void QFontEngineMulti::ensureEngineAt(in
     if (!m_fallbackFamiliesQueried)
         ensureFallbackFamiliesQueried();
     Q_ASSERT(at < m_engines.size());
+    qDebug() << "ensureEngineAt" << at;
     if (!m_engines.at(at)) {
+        qDebug() << "   -- loadingEngineAt" << at;
         QFontEngine *engine = loadEngine(at);
         if (!engine)
             engine = new QFontEngineBox(fontDef.pixelSize);
@@ -1866,17 +1897,17 @@ QFontEngine *QFontEngineMulti::loadEngin
     return 0;
 }
 
-glyph_t QFontEngineMulti::glyphIndex(uint ucs4) const
+QGlyph QFontEngineMulti::glyphIndex(uint ucs4) const
 {
-    glyph_t glyph = engine(0)->glyphIndex(ucs4);
-    if (glyph == 0
+    QGlyph glyph = engine(0)->glyphIndex(ucs4);
+    if (glyph.glyph == 0
             && ucs4 != QChar::LineSeparator
             && ucs4 != QChar::LineFeed
             && ucs4 != QChar::CarriageReturn
             && ucs4 != QChar::ParagraphSeparator) {
         if (!m_fallbackFamiliesQueried)
             const_cast<QFontEngineMulti *>(this)->ensureFallbackFamiliesQueried();
-        for (int x = 1, n = qMin(m_engines.size(), 256); x < n; ++x) {
+        for (int x = 1, n = m_engines.size(); x < n; ++x) {
             QFontEngine *engine = m_engines.at(x);
             if (!engine) {
                 if (!shouldLoadFontEngineForCharacter(x, ucs4))
@@ -1889,9 +1920,8 @@ glyph_t QFontEngineMulti::glyphIndex(uin
                 continue;
 
             glyph = engine->glyphIndex(ucs4);
-            if (glyph != 0) {
-                // set the high byte to indicate which engine the glyph came from
-                glyph |= (x << 24);
+            if (glyph.glyph != 0) {
+                glyph.engine = x;
                 break;
             }
         }
@@ -1909,6 +1939,7 @@ bool QFontEngineMulti::stringToCMap(cons
 
     int glyph_pos = 0;
     QStringIterator it(str, str + len);
+    qDebug() << "stringToCMap";
 
     int lastFallback = -1;
     while (it.hasNext()) {
@@ -1919,35 +1950,34 @@ bool QFontEngineMulti::stringToCMap(cons
         // to get the correct shaping rules applied.
         if (lastFallback >= 0 && (ucs4 == QChar(0x200d) || ucs4 == QChar(0x200c))) {
             QFontEngine *engine = m_engines.at(lastFallback);
-            glyph_t glyph = engine->glyphIndex(ucs4);
-            if (glyph != 0) {
-                glyphs->glyphs[glyph_pos] = glyph;
+            QGlyph glyph = engine->glyphIndex(ucs4);
+            if (glyph.glyph != 0) {
+                glyphs->glyphs[glyph_pos] = QGlyph{lastFallback, glyph.glyph};
                 if (!(flags & GlyphIndicesOnly)) {
                     QGlyphLayout g = glyphs->mid(glyph_pos, 1);
                     engine->recalcAdvances(&g, flags);
-                }
 
-                // set the high byte to indicate which engine the glyph came from
-                glyphs->glyphs[glyph_pos] |= (lastFallback << 24);
+                }
             } else {
                 lastFallback = -1;
             }
         } else {
             lastFallback = -1;
         }
-
-        if (glyphs->glyphs[glyph_pos] == 0
+        if (glyphs->glyphs[glyph_pos].glyph == 0
                 && ucs4 != QChar::LineSeparator
                 && ucs4 != QChar::LineFeed
                 && ucs4 != QChar::CarriageReturn
                 && ucs4 != QChar::ParagraphSeparator) {
             if (!m_fallbackFamiliesQueried)
                 const_cast<QFontEngineMulti *>(this)->ensureFallbackFamiliesQueried();
-            for (int x = 1, n = qMin(m_engines.size(), 256); x < n; ++x) {
+            for (int x = 1, n = m_engines.size(); x < n; ++x) {
                 QFontEngine *engine = m_engines.at(x);
                 if (!engine) {
+                    qDebug() << "not engine at " << x;
                     if (!shouldLoadFontEngineForCharacter(x, ucs4))
                         continue;
+                    qDebug() << "should load engine at " << x << " for character " << ucs4;
                     const_cast<QFontEngineMulti *>(this)->ensureEngineAt(x);
                     engine = m_engines.at(x);
                     if (!engine)
@@ -1957,18 +1987,16 @@ bool QFontEngineMulti::stringToCMap(cons
                 if (engine->type() == Box)
                     continue;
 
-                glyph_t glyph = engine->glyphIndex(ucs4);
-                if (glyph != 0) {
-                    glyphs->glyphs[glyph_pos] = glyph;
+                QGlyph glyph = engine->glyphIndex(ucs4);
+                if (glyph.glyph != 0) {
+                    glyphs->glyphs[glyph_pos] = QGlyph{x, glyph.glyph};
                     if (!(flags & GlyphIndicesOnly)) {
                         QGlyphLayout g = glyphs->mid(glyph_pos, 1);
                         engine->recalcAdvances(&g, flags);
+
                     }
 
                     lastFallback = x;
-
-                    // set the high byte to indicate which engine the glyph came from
-                    glyphs->glyphs[glyph_pos] |= (x << 24);
                     break;
                 }
             }
@@ -1998,18 +2026,14 @@ glyph_metrics_t QFontEngineMulti::boundi
 
     glyph_metrics_t overall;
 
-    int which = highByte(glyphs.glyphs[0]);
+    int which = glyphs.glyphs[0].engine;
     int start = 0;
     int end, i;
     for (end = 0; end < glyphs.numGlyphs; ++end) {
-        const int e = highByte(glyphs.glyphs[end]);
+        const int e = glyphs.glyphs[end].engine;
         if (e == which)
             continue;
 
-        // set the high byte to zero
-        for (i = start; i < end; ++i)
-            glyphs.glyphs[i] = stripped(glyphs.glyphs[i]);
-
         // merge the bounding box for this run
         const glyph_metrics_t gm = engine(which)->boundingBox(glyphs.mid(start, end - start));
 
@@ -2021,20 +2045,11 @@ glyph_metrics_t QFontEngineMulti::boundi
         overall.xoff += gm.xoff;
         overall.yoff += gm.yoff;
 
-        // reset the high byte for all glyphs
-        const int hi = which << 24;
-        for (i = start; i < end; ++i)
-            glyphs.glyphs[i] = hi | glyphs.glyphs[i];
-
         // change engine
         start = end;
         which = e;
     }
 
-    // set the high byte to zero
-    for (i = start; i < end; ++i)
-        glyphs.glyphs[i] = stripped(glyphs.glyphs[i]);
-
     // merge the bounding box for this run
     const glyph_metrics_t gm = engine(which)->boundingBox(glyphs.mid(start, end - start));
 
@@ -2046,19 +2061,13 @@ glyph_metrics_t QFontEngineMulti::boundi
     overall.xoff += gm.xoff;
     overall.yoff += gm.yoff;
 
-    // reset the high byte for all glyphs
-    const int hi = which << 24;
-    for (i = start; i < end; ++i)
-        glyphs.glyphs[i] = hi | glyphs.glyphs[i];
-
     return overall;
 }
 
-void QFontEngineMulti::getGlyphBearings(glyph_t glyph, qreal *leftBearing, qreal *rightBearing)
+void QFontEngineMulti::getGlyphBearings(const QGlyph &glyph, qreal *leftBearing, qreal *rightBearing)
 {
-    int which = highByte(glyph);
-    ensureEngineAt(which);
-    engine(which)->getGlyphBearings(stripped(glyph), leftBearing, rightBearing);
+    ensureEngineAt(glyph.engine);
+    engine(glyph.engine)->getGlyphBearings(glyph, leftBearing, rightBearing);
 }
 
 void QFontEngineMulti::addOutlineToPath(qreal x, qreal y, const QGlyphLayout &glyphs,
@@ -2067,7 +2076,7 @@ void QFontEngineMulti::addOutlineToPath(
     if (glyphs.numGlyphs <= 0)
         return;
 
-    int which = highByte(glyphs.glyphs[0]);
+    int which = glyphs.glyphs[0].engine;
     int start = 0;
     int end, i;
     if (flags & QTextItem::RightToLeft) {
@@ -2075,7 +2084,7 @@ void QFontEngineMulti::addOutlineToPath(
             x += glyphs.advances[gl].toReal();
     }
     for (end = 0; end < glyphs.numGlyphs; ++end) {
-        const int e = highByte(glyphs.glyphs[end]);
+        const int e = glyphs.glyphs[end].engine;
         if (e == which)
             continue;
 
@@ -2084,14 +2093,7 @@ void QFontEngineMulti::addOutlineToPath(
                 x -= glyphs.advances[i].toReal();
         }
 
-        // set the high byte to zero
-        for (i = start; i < end; ++i)
-            glyphs.glyphs[i] = stripped(glyphs.glyphs[i]);
         engine(which)->addOutlineToPath(x, y, glyphs.mid(start, end - start), path, flags);
-        // reset the high byte for all glyphs and update x and y
-        const int hi = which << 24;
-        for (i = start; i < end; ++i)
-            glyphs.glyphs[i] = hi | glyphs.glyphs[i];
 
         if (!(flags & QTextItem::RightToLeft)) {
             for (i = start; i < end; ++i)
@@ -2108,16 +2110,7 @@ void QFontEngineMulti::addOutlineToPath(
             x -= glyphs.advances[i].toReal();
     }
 
-    // set the high byte to zero
-    for (i = start; i < end; ++i)
-        glyphs.glyphs[i] = stripped(glyphs.glyphs[i]);
-
     engine(which)->addOutlineToPath(x, y, glyphs.mid(start, end - start), path, flags);
-
-    // reset the high byte for all glyphs
-    const int hi = which << 24;
-    for (i = start; i < end; ++i)
-        glyphs.glyphs[i] = hi | glyphs.glyphs[i];
 }
 
 void QFontEngineMulti::recalcAdvances(QGlyphLayout *glyphs, QFontEngine::ShaperFlags flags) const
@@ -2125,42 +2118,24 @@ void QFontEngineMulti::recalcAdvances(QG
     if (glyphs->numGlyphs <= 0)
         return;
 
-    int which = highByte(glyphs->glyphs[0]);
+    int which = glyphs->glyphs[0].engine;
     int start = 0;
     int end, i;
     for (end = 0; end < glyphs->numGlyphs; ++end) {
-        const int e = highByte(glyphs->glyphs[end]);
+        const int e = glyphs->glyphs[end].engine;
         if (e == which)
             continue;
 
-        // set the high byte to zero
-        for (i = start; i < end; ++i)
-            glyphs->glyphs[i] = stripped(glyphs->glyphs[i]);
-
         QGlyphLayout offs = glyphs->mid(start, end - start);
         engine(which)->recalcAdvances(&offs, flags);
 
-        // reset the high byte for all glyphs and update x and y
-        const int hi = which << 24;
-        for (i = start; i < end; ++i)
-            glyphs->glyphs[i] = hi | glyphs->glyphs[i];
-
         // change engine
         start = end;
         which = e;
     }
 
-    // set the high byte to zero
-    for (i = start; i < end; ++i)
-        glyphs->glyphs[i] = stripped(glyphs->glyphs[i]);
-
     QGlyphLayout offs = glyphs->mid(start, end - start);
     engine(which)->recalcAdvances(&offs, flags);
-
-    // reset the high byte for all glyphs
-    const int hi = which << 24;
-    for (i = start; i < end; ++i)
-        glyphs->glyphs[i] = hi | glyphs->glyphs[i];
 }
 
 void QFontEngineMulti::doKerning(QGlyphLayout *glyphs, QFontEngine::ShaperFlags flags) const
@@ -2168,48 +2143,29 @@ void QFontEngineMulti::doKerning(QGlyphL
     if (glyphs->numGlyphs <= 0)
         return;
 
-    int which = highByte(glyphs->glyphs[0]);
+    int which = glyphs->glyphs[0].engine;
     int start = 0;
     int end, i;
     for (end = 0; end < glyphs->numGlyphs; ++end) {
-        const int e = highByte(glyphs->glyphs[end]);
+        const int e = glyphs->glyphs[end].engine;
         if (e == which)
             continue;
 
-        // set the high byte to zero
-        for (i = start; i < end; ++i)
-            glyphs->glyphs[i] = stripped(glyphs->glyphs[i]);
-
         QGlyphLayout offs = glyphs->mid(start, end - start);
         engine(which)->doKerning(&offs, flags);
 
-        // reset the high byte for all glyphs and update x and y
-        const int hi = which << 24;
-        for (i = start; i < end; ++i)
-            glyphs->glyphs[i] = hi | glyphs->glyphs[i];
-
         // change engine
         start = end;
         which = e;
     }
 
-    // set the high byte to zero
-    for (i = start; i < end; ++i)
-        glyphs->glyphs[i] = stripped(glyphs->glyphs[i]);
-
     QGlyphLayout offs = glyphs->mid(start, end - start);
     engine(which)->doKerning(&offs, flags);
-
-    // reset the high byte for all glyphs
-    const int hi = which << 24;
-    for (i = start; i < end; ++i)
-        glyphs->glyphs[i] = hi | glyphs->glyphs[i];
 }
 
-glyph_metrics_t QFontEngineMulti::boundingBox(glyph_t glyph)
+glyph_metrics_t QFontEngineMulti::boundingBox(const QGlyph &glyph)
 {
-    const int which = highByte(glyph);
-    return engine(which)->boundingBox(stripped(glyph));
+    return engine(glyph.engine)->boundingBox(glyph);
 }
 
 QFixed QFontEngineMulti::ascent() const
@@ -2268,7 +2224,7 @@ bool QFontEngineMulti::canRender(const Q
 
     int nglyphs = len;
 
-    QVarLengthArray<glyph_t> glyphs(nglyphs);
+    QVarLengthArray<QGlyph> glyphs(nglyphs);
 
     QGlyphLayout g;
     g.numGlyphs = nglyphs;
@@ -2277,7 +2233,7 @@ bool QFontEngineMulti::canRender(const Q
         Q_UNREACHABLE();
 
     for (int i = 0; i < nglyphs; i++) {
-        if (glyphs[i] == 0)
+        if (glyphs[i].glyph == 0)
             return false;
     }
 
